Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 7766)
@@ -445,5 +445,5 @@
       !!----------------------------------------------------------------------
       USE lib_mpp , ONLY: ctl_warn
-      INTEGER ::   ierr(7)        ! Local variables
+      INTEGER ::   ierr(8)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7766)
@@ -533,4 +533,5 @@
       foxy_cons(:,:) = 0.0      !! oxygen consumption
       foxy_anox(:,:) = 0.0      !! unrealised oxygen consumption
+      !!
 # endif
       ftot_n(:,:)   = 0.0       !! N inventory 
@@ -571,4 +572,13 @@
       f_riv_c(:,:)   = 0.0      !! riverine C   input 
       f_riv_alk(:,:) = 0.0      !! riverine alk input 
+      !! 
+      !! Jpalm -- 06-03-2017 -- Forgotten var to init
+      f_omarg(:,:) = 0.0        !!
+      f_omcal(:,:) = 0.0 
+      xFree(:,:) = 0.0          !! state variables for iron-ligand system
+      fcomm_resp(:,:) = 0.0 
+      fprn_ml(:,:) = 0.0        !! mixed layer PP diagnostics
+      fprd_ml(:,:) = 0.0        !! mixed layer PP diagnostics
+
       !!
       !! allocate and initiate 2D diag
@@ -724,5 +734,5 @@
          ENDIF     
 !!
-!! skip FDT_XXXX, RG_XXXXF, FDS_XXXX, RGSXXXXF diagnostics here
+!! skip FDT_XXXX, RG_XXXXF, FDS_XXXX, RGS_XXXXF diagnostics here
 !!
          IF( med_diag%REMINN%dgsave ) THEN
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 7766)
@@ -5,5 +5,5 @@
    !!======================================================================
    !! History :
-   !!  -   !  2014-08  (J. Palmiéri - A. Yool)    added for UKESM1 project
+   !!  -   !  2014-08  (J. Palmieri - A. Yool)    added for UKESM1 project
    !!----------------------------------------------------------------------
 #if defined key_medusa && defined key_roam
@@ -44,5 +44,5 @@
       !!
       !! Title  : Calculates DMS ocean surface concentration
-      !! Author : Julien Palmiéri and Andrew Yool
+      !! Author : Julien Palmieri and Andrew Yool
       !! Date   : 08/08/14 
       !!
@@ -118,5 +118,5 @@
 !
 ! AXY (13/03/15): Simo & Dachs (2002)
-        fq1 = (-1 * log(mld)) + 5.7
+        fq1 = (-1.0 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
         if (cmr < 0.02) then
@@ -136,5 +136,5 @@
 !        
 ! AXY (13/03/15): Halloran et al. (2010)
-        fq1 = (-1 * log(mld)) + 5.7
+        fq1 = (-1.0 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
         fq3 = (90.0 / mld)
@@ -179,2 +179,3 @@
 
 
+
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 7766)
@@ -84,13 +84,9 @@
       &    xburial,                                           &
       &  jriver_n,jriver_si,jriver_c,jriver_alk,jriver_dep,   &
-      &    friver_dep,                                        &
       &  xsdiss,                                              &
-      &  vsed,xhr,                                            &
       &  sedlam,sedlostpoc,jpkb,jdms,jdms_input,jdms_model
 #if defined key_roam
       NAMELIST/natroam/ xthetaphy,xthetazoo,xthetanit,        &
-      &    xthetarem,xo2min,                                  &
-      &    f3_pH,f3_h2co3,f3_hco3,f3_co3,f3_omcal,f3_omarg,   &
-      &    f2_ccd_cal,f2_ccd_arg
+      &    xthetarem,xo2min 
 #endif
       NAMELIST/natopt/xkg0,xkr0,xkgp,xkrp,xlg,xlr,rpig
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90	(revision 7766)
@@ -156,4 +156,7 @@
 
       ! Euphotic layer depth
+      !! Jpalm -- 06-03-2017 -- add init xze, to avoid halo problems within the
+      !!                        writing process
+      xze(:,:) = 0.0
       DO jj = 1, jpj
          DO ji = 1, jpi
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90	(revision 7766)
@@ -41,5 +41,6 @@
 
    PUBLIC   trc_sed_medusa     ! called in ???
-   PUBLIC   trc_sed_medusa_sbc      
+   PUBLIC   trc_sed_medusa_sbc     
+   PUBLIC   trc_sed_medusa_dust 
 
    !! * Module variables
@@ -126,5 +127,4 @@
 
       !! AXY (20/11/14): alter this to report on first MEDUSA call
-      !! IF( kt == nit000 ) THEN
       IF( kt == nittrc000 ) THEN
          IF(lwp) WRITE(numout,*)
@@ -133,59 +133,4 @@
 	 IF(lwp) WRITE(numout,*) ' kt =',kt
       ENDIF
-
-      !! AXY (04/11/13): replace this with a call in trc_ini_medusa
-      !! AXY (25/02/10)
-      !! call routine for populating CCD array if this is the first time-step
-      !! IF( kt == nittrc000 ) CALL medusa_ccd( kt )
-
-      !! AXY (04/11/13): replace this with a call in trc_ini_medusa
-      !! AXY (26/01/12)
-      !! call routine for populating river arrays if this is the first time-step
-      !! IF( kt == nittrc000 ) CALL medusa_river( kt )
-
-      !! AXY (10/02/09)
-      !!IF( (jnt == 1) .and. (bdustfer) )  CALL trc_sed_medusa_sbc( kt )
-
-      !! JPALM -- 31-03-2016 -- rewrite trc_sed_medusa_sbc.
-      !! IF (kt == nittrc000 ) CALL trc_sed_medusa_sbc 
-
-      !! JPALM -- 20-07-2016 -- adapt dust forcing fields reading and conversion
-      !!                     To read dust dep in kg-dust/m2/s instead of g-Fe/m2/month 
-      !!                     So all forcings and coupling dust dep are in the same SI units
-      !!                     and then convert in mmol-Fe/m2/day
-
-      IF( bdustfer ) THEN
-        !! IF( kt == nittrc000 .OR. ( kt /= nittrc000 .AND. ntimes_dust > 1 ) ) THEN
-            CALL fld_read( kt, 1, sf_dust )
-            dust(:,:) = sf_dust(1)%fnow(:,:,1)
-         !! ENDIF
-      ELSEIF (lk_oasis) THEN
-         dust = Dust_in_cpl
-      ELSE
-         dust(:,:) = 0.0
-      ENDIF
-      !!
-      zirondep(:,:) = 0.e0     !! Initialisation of deposition variables
-      zirondep(:,:) = dust(:,:) * Fe_dust_mratio / xfe_mass * 1.e6 * 86400.  !! mmol-Fe/m2/d
-      
-      !! JPALM -- 20-07-2016 -- Zirondep and zsidep are not used.
-      !!                     So comment out the following lines. but keep them
-      !!                     as we may want to used them later on
-      !!================================================     
-      !!
-      !! zirondep(:,:,:) = 0.e0     !! Initialisation of deposition variables
-      !! zsidep  (:,:)   = 0.e0
-      !!
-      !! Iron and Si deposition at the surface
-      !! -------------------------------------
-      !!
-      !! DO jj = 1, jpj
-      !!    DO ji = 1, jpi
-      !!       zirondep(ji,jj,1) = (dustsolub * dust(ji,jj) / (55.85 * rmtss) + 3.e-10 / ryyss) &
-      !!       & * rfact2 / fse3t(ji,jj,1)
-      !!       zsidep  (ji,jj)   = 8.8 * 0.075 * dust(ji,jj) * rfact2 / &
-      !!       & (fse3t(ji,jj,1) * 28.1 * rmtss)
-      !!    END DO
-      !! END DO
 
       ! sedimentation of detrital nitrogen : upstream scheme
@@ -412,4 +357,83 @@
    END SUBROUTINE trc_sed_medusa_sbc
 
+   !! ======================================================================
+   !! ======================================================================
+   !! ======================================================================
+
+   !! AXY & JPALM (28/02/17)
+
+   SUBROUTINE trc_sed_medusa_dust( kt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_sed_medusa_dust  ***
+      !!
+      !! ** Purpose : compute current dust *before* trc_bio_medusa call
+      !!
+      !! ** Method  : does what it says on the tin
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
+
+      !! AXY (20/11/14): alter this to report on first MEDUSA call
+      IF( kt == nittrc000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) ' trc_sed_medusa_dust: MEDUSA dust timestep'
+         IF(lwp) WRITE(numout,*) ' ~~~~~~~'
+	 IF(lwp) WRITE(numout,*) ' kt =',kt
+      ENDIF
+
+      !! AXY (04/11/13): replace this with a call in trc_ini_medusa
+      !! AXY (25/02/10)
+      !! call routine for populating CCD array if this is the first time-step
+      !! IF( kt == nittrc000 ) CALL medusa_ccd( kt )
+
+      !! AXY (04/11/13): replace this with a call in trc_ini_medusa
+      !! AXY (26/01/12)
+      !! call routine for populating river arrays if this is the first time-step
+      !! IF( kt == nittrc000 ) CALL medusa_river( kt )
+
+      !! AXY (10/02/09)
+      !! IF( (jnt == 1) .and. (bdustfer) )  CALL trc_sed_medusa_sbc( kt )
+
+      !! JPALM -- 31-03-2016 -- rewrite trc_sed_medusa_sbc.
+      !! IF (kt == nittrc000 ) CALL trc_sed_medusa_sbc 
+
+      !! JPALM -- 20-07-2016 -- adapt dust forcing fields reading and conversion
+      !!                     To read dust dep in kg-dust/m2/s instead of g-Fe/m2/month 
+      !!                     So all forcings and coupling dust dep are in the same SI units
+      !!                     and then convert in mmol-Fe/m2/day
+
+      IF( bdustfer ) THEN
+            CALL fld_read( kt, 1, sf_dust )
+            dust(:,:) = sf_dust(1)%fnow(:,:,1)
+      ELSEIF (lk_oasis) THEN
+         dust = Dust_in_cpl
+      ELSE
+         dust(:,:) = 0.0
+      ENDIF
+      !!
+      zirondep(:,:) = 0.e0     !! Initialisation of deposition variables
+      zirondep(:,:) = dust(:,:) * Fe_dust_mratio / xfe_mass * 1.e6 * 86400.  !! mmol-Fe/m2/d
+      
+      !! JPALM -- 20-07-2016 -- Zirondep and zsidep are not used.
+      !!                     So comment out the following lines. but keep them
+      !!                     as we may want to used them later on
+      !!================================================     
+      !!
+      !! zirondep(:,:,:) = 0.e0     !! Initialisation of deposition variables
+      !! zsidep  (:,:)   = 0.e0
+      !!
+      !! Iron and Si deposition at the surface
+      !! -------------------------------------
+      !!
+      !! DO jj = 1, jpj
+      !!    DO ji = 1, jpi
+      !!       zirondep(ji,jj,1) = (dustsolub * dust(ji,jj) / (55.85 * rmtss) + 3.e-10 / ryyss) &
+      !!       & * rfact2 / fse3t(ji,jj,1)
+      !!       zsidep  (ji,jj)   = 8.8 * 0.075 * dust(ji,jj) * rfact2 / &
+      !!       & (fse3t(ji,jj,1) * 28.1 * rmtss)
+      !!    END DO
+      !! END DO
+
+   END SUBROUTINE trc_sed_medusa_dust
+
 #else
    !!======================================================================
@@ -425,2 +449,3 @@
    !!======================================================================
 END MODULE  trcsed_medusa
+
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 7766)
@@ -58,14 +58,21 @@
       ENDIF
 
-      CALL trc_avg_medusa( kt )   ! rolling average module
+      CALL trc_avg_medusa( kt ) ! rolling average module
 # if defined key_debug_medusa
-         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_avg_medusa'
-         CALL flush(numout)
+      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_avg_medusa'
+      CALL flush(numout)
+# endif
+      
+      CALL trc_opt_medusa( kt ) ! optical model
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_opt_medusa'
+      CALL flush(numout)
 # endif
 
-      CALL trc_opt_medusa( kt )   ! optical model
+      !! AXY & JPALM (28/02/17): call dust before trc_bio_medusa (because of coupling)
+      CALL trc_sed_medusa_dust( kt ) ! dust submodel
 # if defined key_debug_medusa
-         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_opt_medusa'
-         CALL flush(numout)
+      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa_dust'
+      CALL flush(numout)
 # endif
 
@@ -75,15 +82,15 @@
       CALL flush(numout)
 # else
-      CALL trc_bio_medusa( kt )   ! biological model
-# if defined key_debug_medusa
-         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_bio_medusa'
-         CALL flush(numout)
-# endif
-
-      CALL trc_sed_medusa( kt )   ! sedimentation model
-# if defined key_debug_medusa
-         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa'
-         CALL flush(numout)
-# endif
+      CALL trc_bio_medusa( kt ) ! biological model
+#  if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_bio_medusa'
+      CALL flush(numout)
+#  endif
+      
+      CALL trc_sed_medusa( kt ) ! sedimentation model
+#  if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa'
+      CALL flush(numout)
+#  endif
 # endif
 
@@ -103,2 +110,3 @@
    !!======================================================================
 END MODULE trcsms_medusa
+
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 7766)
@@ -686,5 +686,5 @@
       !!----------------------------------------------------------------------
       INTEGER  :: jk, jn
-      REAL(wp) :: ztraf, zmin, zmax, zmean, zdrift
+      REAL(wp) :: ztraf, zmin, zmax, zmean, zdrift, areasf
       REAL(wp), DIMENSION(jpi,jpj) :: zvol
       !!----------------------------------------------------------------------
@@ -696,5 +696,6 @@
       ENDIF
       !
-         zvol(:,:) = e1e2t(:,:) * fse3t_a(:,:,1) * tmask(:,:,1)
+      zvol(:,:) = e1e2t(:,:) * fse3t_a(:,:,1) * tmask(:,:,1)
+      areasf = glob_sum(zvol(:,:))
       DO jn = 1, jptra
          ztraf = glob_sum( tra(:,:,1,jn) * zvol(:,:) )
@@ -705,5 +706,5 @@
             CALL mpp_max( zmax )      ! max over the global domain
          END IF
-         zmean  = ztraf / areatot
+         zmean  = ztraf / areasf
          IF(lwp) WRITE(numout,9001) jn, TRIM( ctrcnm(jn) ), zmean, zmin, zmax
       END DO
@@ -734,5 +735,6 @@
       zvol(:,:) = e1e2t(:,:) * fse3t_a(:,:,1) * tmask(:,:,1)
       ztraf = glob_sum( dgtr(:,:) * zvol(:,:) )
-      areasf = glob_sum(e1e2t(:,:) * tmask(:,:,1) )
+      !! areasf = glob_sum(e1e2t(:,:) * tmask(:,:,1) )
+      areasf = glob_sum(zvol(:,:))
       zmin  = MINVAL( dgtr(:,:), mask= ((tmask(:,:,1).NE.0.)) )
       zmax  = MAXVAL( dgtr(:,:), mask= ((tmask(:,:,1).NE.0.)) )
@@ -741,5 +743,5 @@
          CALL mpp_max( zmax )      ! max over the global domain
       END IF
-      zmean  = ztraf / areatot
+      zmean  = ztraf / areasf
       IF(lwp) WRITE(numout,9002) TRIM( names ), zmean, zmin, zmax
       !
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 7720)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 7766)
@@ -146,5 +146,5 @@
             ztrai = ztrai + glob_sum( trn(:,:,:,jn) * cvol(:,:,:)   )
          END DO
-         IF( lwp ) WRITE(numstr,9300) kt,  ztrai / areatot
+         IF( numstr /= -1 ) WRITE(numstr,9300) kt,  ztrai / areatot
 9300     FORMAT(i10,e18.10)
       ENDIF
